#!/bin/sh
#choose an installed pkg and find all its dependencies.
#V4.20 Localization by J.J. Moulinier March 2009. Many thanks to Mark Ulrich.

#-- simple localization for scripts by MU. 
mo=check_deps.mo
lng=`echo $LANG | sed "s/\(..\).*/\1/"`
#echo $lng
. "/usr/share/locale/en/LC_MESSAGES/$mo"
if [ -f "/usr/share/locale/$lng/LC_MESSAGES/$mo" ];then
  . "/usr/share/locale/$lng/LC_MESSAGES/$mo"
fi

PKGS2ADD=""

#determine current pet pkg repo...
PUPPYVERSION="`cat /etc/puppyversion`"
xPUPPYVERSION="$PUPPYVERSION"
[ $PUPPYVERSION -eq 398 ] && xPUPPYVERSION=400 #temp fixup.
[ $PUPPYVERSION -eq 399 ] && xPUPPYVERSION=400 #temp fixup.
PUPVERDIGIT1="`echo -n "$xPUPPYVERSION" | cut -c 1`"
#PUPREPO=$PUPVERDIGIT1
##this file was created by /usr/local/petget/pkg_chooser.sh, which repository to get pkg from...
#[ -f /tmp/petget_filterversion ] && PUPREPO="`cat /tmp/petget_filterversion`"
#modPUPREPO="$PUPREPO"
#[ "$PUPREPO" = "$PUPVERDIGIT1" ] && modPUPREPO="" #current livepackages.txt does not have a repo#.


dependcheckfunc() {
 FLAGDEPPKG="no"
 [ "$WKGDIR" = "" ] && WKGDIR='.' #i expect this to be set, precaution.
 echo -n "" > /tmp/missinglibs.txt
 echo -n "" > /tmp/missinglibs0.txt
  #v1.0.4 
  #for openoffice, really need to add /usr/OpenOffice.org1.1.4/program to LD_LIBRARY_PATH,
  #but cannot be bothered for now... nah, do something now...
  if [ ! "`echo -n "$APKGNAME" | grep "openoffice"`" = "" ];then
   #return #bypass dependency check.
   if [ "`echo "$LD_LIBRARY_PATH" | grep "OpenOffice"`" = "" ];then
    [ -d /usr/OpenOffice.org1.1.4 ] && LD_LIBRARY_PATH="/usr/OpenOffice.org1.1.4/program:$LD_LIBRARY_PATH"
    [ -d /opt/openoffice.org2.2 ] && LD_LIBRARY_PATH="/opt/openoffice.org2.2/program:$LD_LIBRARY_PATH"
    export LD_LIBRARY_PATH
    #...need to generalise this code for different versions of openoffice.
   fi
  fi
 FNDFILES="`cat $WKGDIR/$APKGNAME.files`"
 for ONEFILE in $FNDFILES
 do
  ISANEXEC="`file --brief $ONEFILE | grep --extended-regexp "LSB executable|shared object"`"
  if [ ! "$ISANEXEC" = "" ];then
   LDDRESULT="`ldd $ONEFILE`"
   MISSINGLIBS="`echo "$LDDRESULT" | grep "not found" | cut -f 2 | cut -f 1 -d " " | tr "\n" " "`"
   if [ ! "$MISSINGLIBS" = "" ];then
    echo "${Loc_MISSINGLIBS1} $ONEFILE ${Loc_MISSINGLIBS1}:" >> /tmp/missinglibs.txt
    echo " $MISSINGLIBS" >> /tmp/missinglibs.txt
   fi
  fi
 done
 sync
 #find any dependent packages...
 #second field in comments-field has a comma-delimited list of dependencies...
 cp -f $WKGDIR/packages.txt /tmp/tempzzz
 if [ "$modPUPREPO" = "unknown" ];then
  [ -f $WKGDIR/alienpackages.txt ] && cat $WKGDIR/alienpackages.txt >> /tmp/tempzzz
  for ONEREPO in $ALLREPOS
  do
   cat /root/.packages/livepackages${ONEREPO}txt >> /tmp/tempzzz
  done
 else
  [ -f $WKGDIR/livepackages${modPUPREPO}.txt ] && cat $WKGDIR/livepackages${modPUPREPO}.txt >> /tmp/tempzzz
  [ -f $WKGDIR/alienpackages.txt ] && cat $WKGDIR/alienpackages.txt >> /tmp/tempzzz
 fi
 BPATTERN="^\"${APKGNAME}\" "
 #creates list, each line in format "pkgname ...
 DEPENDPKGS="`cat /tmp/tempzzz | grep "$BPATTERN" | head -n 1 | cut -f 6 -d '"' | cut -f 2 -d " " | tr "," "\n" | grep "^\+" |  sed -e 's/^\+//g'`" #'geany
 if [ ! "$DEPENDPKGS" = "" ];then
  for ADEPENDPKG in $DEPENDPKGS
  do
   namePATTERN1=" \"${ADEPENDPKG} " #name only
   namePATTERN2=" \"${ADEPENDPKG}-" #some alienpackage.txt entries may have incorrect format, no space after pkg name.
   namePATTERN3="^\"${ADEPENDPKG}\" " #dependency has version as well.
   if [  "`cat /tmp/tempzzz | grep '" on "' | grep -E "${namePATTERN1}|${namePATTERN2}|${namePATTERN3}"`" = "" ];then
   
    FLAGDEPPKG="yes"
    echo "${Loc_FLAGDEPPKG}: \"$ADEPENDPKG\" " >> /tmp/missinglibs.txt

   fi
  done
 fi
 TESTONLY=""
} #end dependcheckfunc


cd /root/.packages

echo -n "" > /tmp/user_on_pkgs_dep_chk
repPATTERN="s%\" on \"% REPO:unknown\" on \"%"
[ -f /root/.packages/alienpackages.txt ] && grep '" on "' /root/.packages/alienpackages.txt | sed "$repPATTERN" >> /tmp/user_on_pkgs_dep_chk
sync
repPATTERN="s%\" on \"% REPO:${PUPVERDIGIT1}\" on \"%"
[ -f /root/.packages/livepackages.txt ] && grep '" on "' /root/.packages/livepackages.txt | sed "$repPATTERN" >> /tmp/user_on_pkgs_dep_chk
sync
ALLREPOS="`ls -1 /root/.packages/livepackages*.txt | grep -o 'livepackages.*\.' | sed -e 's/livepackages//'`"
for ONEREPO in $ALLREPOS
do
 [ "$ONEREPO" = "." ] && continue
 xONEREPO="`echo -n "$ONEREPO" | sed -e 's/\.$//'`"
 repPATTERN="s%\" on \"% REPO:${xONEREPO}\" on \"%"
 grep '" on "' /root/.packages/livepackages${ONEREPO}txt | sed "$repPATTERN" >> /tmp/user_on_pkgs_dep_chk
 sync
done
PKGSONLIST="`cat /tmp/user_on_pkgs_dep_chk`"

if [ "$PKGSONLIST" != "" ];then
 rm -f /tmp/rettags.txt
 echo '#!/bin/sh' > /tmp/pkgdialog
 echo 'RETTAGS="`Xdialog --title "'${Loc_title}'" --left --stdout  --item-help --icon "/usr/local/lib/X11/pixmaps/pet48x.png" --no-cancel --no-tags --radiolist "'${Loc_titletext1}'" 460x270+0+0 0 \' >> /tmp/pkgdialog
 echo "$PKGSONLIST" >> /tmp/pkgdialog
 echo ' `"' >> /tmp/pkgdialog
 echo 'if [ ! $? -eq 0 ];then' >> /tmp/pkgdialog
 echo ' exit'  >> /tmp/pkgdialog
 echo 'fi' >> /tmp/pkgdialog
 echo 'echo "$RETTAGS" > /tmp/rettags.txt' >> /tmp/pkgdialog
 sync #` geany fix.
 chmod 755 /tmp/pkgdialog
 /tmp/pkgdialog
 APKGNAME="`cat /tmp/rettags.txt 2> /dev/null`"
 if [ "$APKGNAME" = "" ];then
  exit
 fi
 apkgPATTERN='^'"\"${APKGNAME}\" "
 APKGENTRY="`grep "$apkgPATTERN" /tmp/user_on_pkgs_dep_chk`"
 PUPREPO="`echo "$APKGENTRY" | grep -o 'REPO:.*" ' | cut -f 2 -d ':' | cut -f 1 -d '"'`"
 modPUPREPO=$PUPREPO
 [ "$modPUPREPO" = "$PUPVERDIGIT1" ] && modPUPREPO="" #current livepackages.txt does not have a repo#.
 yaf-splash -font "8x16" -outline 0 -margin 4 -bg orange -text "${Loc_check1}" & #9x15B also looks okay.
 DEPSPID=$!
 dependcheckfunc #function. requires APKGNAME and modPUPREPO.
 kill $DEPSPID
 if [ -s /tmp/missinglibs.txt ];then
  if [ "$FLAGDEPPKG" = "yes" ];then
   WARNLIB="${Loc_check2}"
  else
   WARNLIB="${Loc_check3}"
  fi
  if [ ! "$DISABLEDX" = "yes" ];then
   gxmessage -font "mono 14" -name "pet" -bg "#ff8080" -center -title "${Loc_check4}" "${Loc_check5} $APKGNAME ${Loc_check6}:
`cat /tmp/missinglibs.txt`

$WARNLIB"
  fi
 else
  if [ ! "$DISABLEDX" = "yes" ];then
   gxmessage -name "pet" -bg "green" -center -title "${Loc_check7}" "${Loc_check8}"
  fi
 fi
fi

###END###
